unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, RegComp, Grids, Buttons;

type
  TForm1 = class(TForm)
    Button1: TButton;
    RegComp1: TRegComp;
    Label1: TLabel;
    StringGrid1: TStringGrid;
    Button3: TButton;
    sbExit: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure sbExitClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    NumberObs: integer;
    NumberVars: integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  NumberVars  := 8;
  NumberObs   := 800;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,j: integer;
begin
  Screen.Cursor:= crHourglass;

  Randomize;           // Use quasi-random values for the example here
  RegComp1.MVPrepare;  // Initialize container array(s)
                       // You must call this once during life of the program-
                       // normally as soon as any processing takes place...

  // Assign some values to X1..X18 vars: (random here in this case)
  for i:= 1 to NumberVars do
     for j:= 0 to NumberObs-1 do
        RegComp1.PRegressData^[i,j]:= i + Random(200);

  // Assign values to Y var: (again, some quasi-random values)
  for j:= 0 to NumberObs-1 do
     RegComp1.Y[j]:= Random(40);

  Screen.Cursor:= crDefault;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i,j: byte;
begin
  Screen.Cursor:= crHourglass;
  StringGrid1.Enabled:= FALSE;

  with RegComp1 do begin
     CorMatrix:= RegComp1.CorrelationMatrix(PRegressData,NumberVars,NumberObs);

     for i:= 1 to NumberVars do
        for j:= 1 to NumberVars do
           StringGrid1.Cells[i,j]:= Format('%4.2f',[ CorMatrix[i,j] ] );
  end;

  StringGrid1.Enabled:= TRUE;
  Screen.Cursor:= crDefault;
end;

procedure TForm1.sbExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  i,j: byte;
begin
  Screen.Cursor:= crHourglass;
  StringGrid1.Enabled:= FALSE;

  with RegComp1 do begin
     CovMatrix:= RegComp1.CovarianceMatrix(PRegressData,NumberVars,NumberObs);

     for i:= 1 to NumberVars do
        for j:= 1 to NumberVars do
           StringGrid1.Cells[i,j]:= Format('%4.2f',[ CovMatrix[i,j] ] );
  end;

  StringGrid1.Enabled:= TRUE;
  Screen.Cursor:= crDefault;
end;

end.
